#ifndef _BITMAP_H_INCLUDED_
#define _BITMAP_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Bitmap.h
// --------
// Bitmap class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke                        
//
// INTERFACE MODULE
//
// Class: Bitmap
// 
// Description: This class provides bitmap management for boolean data
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


// INCLUDES

#include "Chain.h"

class Bitmap {

public:
    
    Bitmap(int size);
    ~Bitmap();
    
    void setValue(int pos, bool val);
    bool getValue(int pos) const;
   
    Chain toChain() const;

    Bitmap& operator = ( const Bitmap& bm);
    bool operator == ( const Bitmap& bm) const;
  
private:

    char *_pBM;
    int _size;
};



#endif



