#ifndef _COMMANDEXECUTER_H_INCLUDED_
#define _COMMANDEXECUTER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// CommandExecuter.h  
// -----------------
// Executing commands via process forking 
//                                                        
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2007-2013 Bjoern Lemke                        
//
// INTERFACE MODULE
//
// Class: CommandExecuter
// 
// Description:
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

// BASE INCLUDES
#include "Chain.h"
#include "ListT.h"
#include "SigHandler.h"


// DEFINES
#define DEFTIMEOUT 60 

class CommandExecuter  : public SigHandler {
    
public:
    
    CommandExecuter(const Chain& shellPath = Chain("/bin/sh"));
    ~CommandExecuter();
    
    int execute(const Chain& command, int timeout = DEFTIMEOUT);
    
private:

    Chain _shellPath;
    void sigCatch(int sig);
    int _childPid;
};

#endif







