#ifndef _DATETIME_H_INCLUDED_
#define _DATETIME_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Datetime.h
// ----------
// implementation of a datetime data type
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke                        
//
// INTERFACE MODULE
//
// Class: Datetime
// 
// Description: datetime utility class
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

#include <time.h>
#include "Chain.h"


#ifdef HAVE_MINGW32
extern "C" char* strptime(const char* s,const char* format, struct tm* tm);
#endif


class Datetime {

public:
  
  Datetime();
  Datetime(const Chain& v);
  Datetime(const Chain& v, const Chain& format);
  Datetime(int i);
  
  ~Datetime();

  Chain asChain() const;
  Chain asChain(const Chain& format) const;
  int asInt() const;

  void add(int seconds);
  void sub(int seconds);

  // member operators

  Datetime& operator = ( const Datetime& d);
  bool operator == ( const Datetime& str) const;
  bool operator != ( const Datetime& str) const;
  bool operator < ( const Datetime& str) const;
  bool operator > ( const Datetime& str) const;
  bool operator <= ( const Datetime& str) const;
  bool operator >= ( const Datetime& str) const;

  // friend operators
  friend ostream& operator << (ostream& s, const  Datetime& str);
  

private:

  time_t _t;

};



#endif



