#ifndef _MATCHER_H_INCLUDED_
#define _MATCHER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Matcher.h
// --------
// Matcher class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke                        
//
// INTERFACE MODULE
//
// Class: Matcher 
// 
// Description:
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////


// INCLUDES
#include <iostream>
#include <sys/types.h>

#ifdef HAVE_MINGW32
#include "regex.h"
#else
#include <regex.h>
#endif

class Matcher {

public:
    
    Matcher(const Chain& exp);
    ~Matcher();
    
    void prepare();

    bool match(const Chain& str);
    
private:
    
    Chain _expr;
    regex_t* _pRE;  
    bool _isPrepared;
};

#endif



