#ifndef _NANOTIMER_H_INCLUDED_
#define _NANOTIMER_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// NanoTimer.h
// -----------
// NanoTimer class definition
//                                                         
// Design and Implementation by Bjoern Lemke               
// 
// (C)opyright 2000-2013 Bjoern Lemke                        
//                                                         
// INTERFACE MODULE
//
// Class: NanoTimer 
// 
// Description: NanoTimer class for time measurement
//
// Status: IMPLEMENTED 
///////////////////////////////////////////////////////////////////////////////


// INCLUDES
#ifdef HAVE_MINGW32
#include <windows.h>
#else
#include <sys/time.h>
#endif

class NanoTimer {

public:
    
    NanoTimer();
    ~NanoTimer();
    void start();
    void stop();

    long getSum() const;
    void reset();
    
private:

#ifdef HAVE_MINGW32
    LONGLONG _start, _end, _sum, _freq; 
#else
    long long _start, _end, _sum;
#endif

};

#endif



