#ifndef _THREAD_H_INCLUDED_
#define _THREAD_H_INCLUDED_
///////////////////////////////////////////////////////////////////////////////
//                                                         
// Thread.h
// --------
// Thread class interface definition
//                                                         
// Design and Implementation by Bjoern Lemke               
//                                                         
// (C)opyright 2000-2013 Bjoern Lemke                        
//                                                         
// INTERFACE MODULE
//
// Class: Thread
// 
// Description: all operations on POSIX threads
//
// Status: IMPLEMENTED
///////////////////////////////////////////////////////////////////////////////

#ifndef _REENTRANT
#define _REENTRANT    /* basic 3-lines for threads */
#endif


class Thread 
{
    
public:
    Thread();
    ~Thread();
    
    long start(void *arg);
    void join(long tid);
    void cancel();
    
    void P();
    void V();
    
    long getTid() { return _tid; };

protected:
    
    virtual void* job(void *arg) = 0;
    
    void *getArg() { return _arg; }

private:
    
    static void* task(void *pThis);

    long _tid;    
    void *_arg;
};

#endif

